Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jet.api
Class MultiUserCatalogAPI

    java.lang.Object
      jet.api.API
          jet.api.CatalogAPI
              jet.api.MultiUserCatalogAPI

    public class MultiUserCatalogAPI

extends CatalogAPI

MultiUserCatalogAPI class provides methods to manipulate the catalog objects. By building a MultiUserCatalogAPI instance in a Java program, several users can edit one catalog at the same time. In MultiUserCatalogAPI, users can share public resources and hold private resources which can not be accessed by other users until they are published to public resources. Uses userID to identify users and protect the private data objects. * Below is an example of the use of the `MultiUserCatalogAPI`.

>       MultiUserDesigner mudr = null;
>       try
>       {
>             String path = %install root%/JReport/demo/reports/SampleReports/;
>             String catName = "SampleReports.cat";
>             String uID = "user1";
>             DesignerUserInfo userInfo=new DesignerUserInfo("UID", "license key");
>             mudr = new MultiUserDesigner(path, catName, userInfo);
>             MultiUserCatalogAPI mucat = mudr.getCatalogAPI();
>             String[] parameters = mucat.getParameter(uID);
>       }
>       catch(Exception e)
>       {
>             ;
>       }
>       finally
>       {
>             mudr.exit();
>       }

Field Summary

Fields inherited from class jet.api.CatalogAPI
`ALIAS, AVERAGE, BINARY, BOOLEAN, BUSINESSLOGIC, BUSINESSLOGIC_CATEGORY, BUSINESSLOGIC_DETAILINFO, BUSINESSLOGIC_DIMENSION, BUSINESSLOGIC_HIERARCHY, BUSINESSLOGIC_HIERARCHYCONTAINER, BUSINESSLOGIC_MEASURE, BUSINESSVIEW, BUSINESSVIEW_AGGREGATION, BUSINESSVIEW_DETAIL, BUSINESSVIEW_GROUP, CATALOG, COLUMN, CONNECTION, COUNT, CURRENCY, DATABASE, DATE, DATETIME, DECIMAL, DISTINCTCOUNT, ENCODINGAUTO, ENCODINGNO, ENCODINGYES, EXTRA_NAME_JDBC, EXTRA_NAME_USERDEFINED, FILESQL, FORMULA, HDS, INTEGER, JDBC, JDBC_ODBC_BRIDGE, MAXIMUM, MINIMUM, NUMBER, ONDEMAND_QUERY, PARAMETER, PARAMETERS, PATTERN_1PART_NAME, PATTERN_2PART_NAME, PATTERN_3PART_NAME, POPULATIONSTDDEV, POPULATIONVARIANCE, PROCEDURE, QUERY, READ_ONLY_DEFAULT, READ_ONLY_FALSE, READ_ONLY_TRUE, RUNNING_AVERAGE, RUNNING_COUNT, RUNNING_DISTINCTCOUNT, RUNNING_MAXIMUM, RUNNING_MINIMUM, RUNNING_SUM, STDDEV, STRING, SUM, SUMMARY, SYNONYM, TABLE, TIME, TRANSACTION_DEFAULT, TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE, UDS, UNIFIEDBUSINESSVIEW, VARIANCE, VIEW, WHEREPORTION, WSDLTYPE_LOCALEFILE, WSDLTYPE_URI, XML_CONNECTION, XML_MDCONTAINER`

Fields inherited from class jet.api.API
`CAT, CENTIMETER, COLOR, DOUBLE, ENUM, FLOAT, INCH, LONG, PIXEL, REFERENCE, RPT, SELFRPT, TEXTRPT, UNKNOWN, XMLCAT, XMLRPT`

Method Summary
`boolean` | `delete(java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo, java.lang.String uID)` Deletes the join from the query.
`boolean` | `delete(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo, java.lang.String uID)` Deletes the join in the query.
`boolean` | `deleteAND(java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic, java.lang.String uID)` Deletes where conditions in the query.
`boolean` | `deleteAND(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic, java.lang.String uID)` Deletes where conditions in the query.
`boolean` | `deleteColumn(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String uID)` Deletes the field from the query.
`boolean` | `deleteColumn(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String uID)` Deletes the field from the query.
`boolean` | `deleteCompCol(java.lang.String qryName, java.lang.String columnName, java.lang.String uID)` delete a computed column into query.
`boolean` | `deleteCompCol(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String columnName, java.lang.String uID)` delete a computed column into query.
`boolean` | `deleteQBE(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression, java.lang.String uID)` Deletes the QBE condition in the query.
`boolean` | `deleteQBE(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression, java.lang.String uID)` Deletes the QBE condition in the query.
`boolean` | `deleteQuery(java.lang.String qryName, java.lang.String uID)` Deletes the query from the default data source.
`boolean` | `deleteQuery(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String uID)` Deletes the query from the specified data source of the catalog.
`boolean` | `deleteTable(java.lang.String qryName, java.lang.String tablename, java.lang.String uID)` Deletes the table from the query.
`boolean` | `deleteTable(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String uID)` Deletes the table from the query.
`java.lang.String[][]` | `getAndConditions(java.lang.String queryName, java.lang.String uID)` Gets "AND" conditions in the query
`java.lang.String[][]` | `getAndConditions(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets "AND" conditions in the query
`java.lang.String[]` | `getChartFunctions(java.lang.String queryName, java.lang.String groupBy, java.lang.String uID)` Gets formulas and summaries which are valid to the query and are grouped on this field.
`java.lang.String[]` | `getChartFunctions(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String groupBy, java.lang.String uID)` Gets formulas and summaries which are valid to the query and are grouped on this field.
`java.lang.String[]` | `getColumnMappingnames(java.lang.String queryName, java.lang.String uID)` Gets column mapping names in the query
`java.lang.String[]` | `getColumnMappingnames(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets column mapping names in the query
`QueryTableInfo` | `getColumns(java.lang.String queryName, boolean allColumns, java.lang.String uID)` Gets definitions of all tables and columns in the query.
`QueryTableInfo` | `getColumns(java.lang.String dataSourceName, java.lang.String queryName, boolean allColumns, java.lang.String uID)` Gets definitions of all tables and columns in the query.
`QueryTableInfo` | `getColumnsCanBeGroupedBy(java.lang.String queryName, java.lang.String uID)` Gets columns which can be groupby in the query
`QueryTableInfo` | `getColumnsCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets columns which can be groupby in the query
`java.lang.String[]` | `getCompColumns(java.lang.String queryName, java.lang.String uID)` Gets all mapping names of the computed columns in the query.
`java.lang.String[]` | `getCompColumns(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets all mapping names of the computed columns in the query.
`java.lang.String[]` | `getDBFields(java.lang.String qryName, java.lang.String uID)` Gets mapping names of DBField that are defined in the query of the default data source.
`java.lang.String[]` | `getDBFields(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String uID)` Gets mapping names of DBFields that are defined in the query of the specified data source.
`java.lang.String[]` | `getFmlCanBeGroupedBy(java.lang.String queryName, java.lang.String uID)` Gets formulas which are valid to query and can be grouped on
`java.lang.String[]` | `getFmlCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets formulas which are valid to query and can be grouped on
`java.lang.String[]` | `getFormulae(java.lang.String uID)` Gets all formulas' mapping names that are defined in the default data source.
`java.lang.String[]` | `getFormulae(java.lang.String dataSourceName, java.lang.String uID)` Gets all formulas' mapping names that are defined in the specified data source.
`java.lang.String[]` | `getFormulaeCanBeGroupedBy(java.lang.String queryName, java.lang.String groupBy, java.lang.String uID)` Gets formulas which are valid to query
`java.lang.String[]` | `getFormulaeCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String groupBy, java.lang.String uID)` Gets formulas which are valid to query
`java.lang.String[]` | `getFormulaeForQuery(java.lang.String queryName, java.lang.String uID)` Gets formulas which are valid to query
`java.lang.String[]` | `getFormulaeForQuery(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets formulas which are valid to query
`java.lang.String` | `getHandle(java.lang.String resourceName, int type, java.lang.String uID)` get the object handle
`java.lang.String` | `getHandle(java.lang.String resourceName, java.lang.String uID)` get the object handle
`java.lang.String` | `getHandle(java.lang.String dataSourceName, java.lang.String resourceName, int type, java.lang.String uID)` Gets the handle of an object according to the object's mapping name and object type in the specified data source in JReport catalog, which can identify the object in the catalog.
`java.lang.String` | `getHandle(java.lang.String dataSourceName, java.lang.String resourceName, java.lang.String uID)` get the object handle
`java.lang.String[][]` | `getJoins(java.lang.String queryName, java.lang.String uID)` Gets joins in the query
`java.lang.String[][]` | `getJoins(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets joins in the query
`java.lang.String` | `getNewFormulaName(java.lang.String uID)` Gets the default mapping name for the Formula to be created in the current catalog, which must be unique.
`java.lang.String` | `getNewFormulaName(java.lang.String dataSourceName, java.lang.String uID)` Gets the default Formula name for the Formula to be created in the current catalog, which must be unique.
`java.lang.String` | `getNewParameterName(java.lang.String uID)` Gets the default Parameter name for the Parameter to be created in the current catalog, which must be unique.
`java.lang.String` | `getNewParameterName(java.lang.String dataSourceName, java.lang.String uID)` Gets the default mapping name for the new parameter in the current catalog, which must be unique.
`java.lang.String` | `getNewSummaryName(java.lang.String uID)` Gets the default mapping name for the Summary to be created in the current catalog, which must be unique.
`java.lang.String` | `getNewSummaryName(java.lang.String dataSourceName, java.lang.String uID)` Gets the default mapping name for the Summary to be created in the current catalog, which must be unique.
`java.lang.String[]` | `getParameter(java.lang.String uID)` Gets all mapping names of Parameters in the default data source.
`java.lang.String[]` | `getParameter(java.lang.String dataSourceName, java.lang.String uID)` Gets all mapping names of Parameters in the specified data source.
`java.lang.String[]` | `getParameterCanBeGroupedBy(java.lang.String uID)` Gets parameters which can be grouped by
`java.lang.String[]` | `getParameterCanBeGroupedBy(java.lang.String dataSourceName, java.lang.String uID)` Gets parameters which can be grouped by
`java.lang.String[][]` | `getQBEInfo(java.lang.String queryName, java.lang.String uID)` Gets QBE information in the query
`java.lang.String[][]` | `getQBEInfo(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets QBE information in the query
`java.lang.String[]` | `getQueries(java.lang.String uID)` Gets all mapping names of Queries in the default data source.
`java.lang.String[]` | `getQueries(java.lang.String dataSourceName, java.lang.String uID)` Gets all mapping names of Queries in the default data source.
`java.lang.String[]` | `getSQLs(java.lang.String uID)` Gets all mapping names of Imported SQL queries in the default data source.
`java.lang.String[]` | `getSQLs(java.lang.String dataSourceName, java.lang.String uID)` Gets all mapping names of Imported SQL queries in the specified data source.
`java.lang.String[]` | `getSummaries(java.lang.String uID)` Gets all summaries mapping names that are defined in the specified data source.
`java.lang.String[]` | `getSummaries(java.lang.String dataSourceName, java.lang.String uID)` Gets all summaries mapping names that are defined in the specified data source.
`java.lang.String[]` | `getSummariesForQuery(java.lang.String queryName, java.lang.String uID)` Gets Summaries which are valid to query
`java.lang.String[]` | `getSummariesForQuery(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String uID)` Gets Summaries which are valid to query
`java.lang.String[]` | `getSummaryCanBeSortedBy(java.lang.String queryName, java.lang.String groupBy, java.lang.String uID)` Gets summary which can be sorted by
`java.lang.String[]` | `getSummaryCanBeSortedBy(java.lang.String dataSourceName, java.lang.String queryName, java.lang.String groupBy, java.lang.String uID)` Gets summary which can be sorted by
`java.lang.String[]` | `getTables(java.lang.String uID)` Gets all mapping names of Tables in the default data source.
`java.lang.String[]` | `getTables(java.lang.String dataSourceName, java.lang.String uID)` Gets all mapping names of Tables in the specified data source.
`java.lang.String[]` | `getUDSs(java.lang.String uID)` Gets all mapping names of UDSs in the default data source.
`java.lang.String[]` | `getUDSs(java.lang.String dataSourceName, java.lang.String uID)` Gets all mapping names of UDSs in the default data source.
`java.lang.String` | `insert(java.lang.String name, int type, java.lang.String uID)` Adds a resource entity into the catalog.
`java.lang.String` | `insert(java.lang.String qryName, QueryFieldInfo queryFieldInfo, QueryJoinInfo queryJoinInfo, QueryQBEInfo queryQBEInfo, QueryAndInfo queryAndInfo, java.lang.String uID)` Inserts a query into the catalog.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String name, int type, java.lang.String uID)` Adds a resource entity into a specified data source in the catalog.
`java.lang.String` | `insert(java.lang.String dataSourceName, java.lang.String qryName, QueryFieldInfo queryFieldInfo, QueryJoinInfo queryJoinInfo, QueryQBEInfo queryQBEInfo, QueryAndInfo queryAndInfo, java.lang.String uID)` Inserts a query into the catalog.
`java.lang.String` | `insertCompCol(java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression, java.lang.String uID)` Inserts a computed column into query.
`java.lang.String` | `insertCompCol(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression, java.lang.String uID)` Inserts a computed column into query.
`java.lang.String` | `insertSql(java.lang.String dataSourceName, java.lang.String SQLName, java.lang.String filename, java.lang.String uID)` Imports an SQL file
`boolean` | `isModified()` whether the catalog was modified
`java.lang.String` | `rename(java.lang.String resourceName, java.lang.String newName, int type, java.lang.String uID)` Renames the mapping name of the specified object.
`java.lang.String` | `rename(java.lang.String dataSourceName, java.lang.String resourceName, java.lang.String newName, int type, java.lang.String uID)` Renames the mapping name of the specified object.
`boolean` | `save(java.lang.String uID)` Saves all private objects of the specified user to the public resource (catalog).
`boolean` | `save(java.lang.String handle, java.lang.String uID)` Only saves the specified private data object of the specified user to the public resource (the default data source of the catalog).
`boolean` | `save(java.lang.String dataSource, java.lang.String handle, java.lang.String uID)` Only saves the specified private data object of the specified user to the public resource (catalog).
`boolean` | `saveCatalog(java.lang.String uID, java.lang.String dataSource)` Saves the private data objects of the specified user to the public resource (catalog).
`boolean` | `set(java.lang.String handle, FormulaInfo info, java.lang.String uID)` Sets the Formula's information.
`boolean` | `set(java.lang.String qryName, java.lang.String tablename, boolean selectAllFields, java.lang.String uID)` Adds a new table into the query.
`boolean` | `set(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, boolean isFormula, java.lang.String uID)` Adds a new table's field into the query of the default data source.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, boolean isFormula, java.lang.String uID)` Adds a new table's field into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo, java.lang.String uID)` Adds a new join to the query.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tableFrom, java.lang.String columnFrom, java.lang.String operator, java.lang.String tableTo, java.lang.String columnTo, java.lang.String uID)` Adds a new join to the query.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, SubQueryInfo subqueryInfo, java.lang.String uID)` Adds a subquery into the query of the specified data source.
`boolean` | `set(java.lang.String dataSourceName, java.lang.String qryName, UnionInfo unionInfo, java.lang.String uID)` Adds a union query into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, SubQueryInfo subqueryInfo, java.lang.String uID)` Adds a subquery into the query of the specified data source.
`boolean` | `set(java.lang.String qryName, UnionInfo unionInfo, java.lang.String uID)` Adds a union query into the query of the default data source.
`boolean` | `setAND(java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic, java.lang.String uID)` Adds a new where condition to the specified query.
`boolean` | `setAND(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String sExpression1, java.lang.String sOperator, java.lang.String sExpression2, java.lang.String sLogic, java.lang.String uID)` Adds a new where condition to the specified query.
`boolean` | `setCompCol(java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression, java.lang.String uID)` modify the expression of a computed column .
`boolean` | `setCompCol(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String columnName, java.lang.String sExpression, java.lang.String uID)` modify the expression of a computed column .
`boolean` | `setNewTable(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, boolean selectAllFields, java.lang.String uID)` Adds a new table into the query
`boolean` | `setQBE(java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression, java.lang.String uID)` Adds a QBE condition into the query.
`boolean` | `setQBE(java.lang.String dataSourceName, java.lang.String qryName, java.lang.String tablename, java.lang.String columnname, java.lang.String expression, java.lang.String uID)` Adds a QBE condition into the query.

Methods inherited from class jet.api.CatalogAPI
`checkParam, create, delete, delete, delete, delete, delete, delete, delete, delete, delete, deleteCompCol, deleteCondition, deleteQuery, deleteQueryField, deleteQueryTable, deleteUnionQuery, getAndConditions, getAndInfos, getAndInfos, getBLCategoryHandles, getBLDetailHandles, getBLDimensionHandles, getBLFilterInfo, getBLFilterInfos, getBLHierarchyHandles, getBLMeasureHandles, getBLNodeQualifyName, getBLViewHandles, getBLViewHandles, getBLViewNames, getBLViewNames, getBusinessNodeNames, getBusinessViewAggregationHandles, getBusinessViewDetailHandles, getBusinessViewGroupHandles, getBusinessViewHandles, getBusinessViewHandles, getBusinessViewNames, getBusinessViewNames, getBusinesViewCategoryHandles, getChartFunctions, getColumnMappingnames, getColumns, getColumns, getColumnsCanBeGroupedBy, getCompColumnHandles, getCompColumns, getConnectionInfo, getConnectionInfo, getConnectionInfo, getDataSources, getDBFields, getDefaultConnectionName, getDefaultDataSourceName, getForeignKeys, getForeignKeys, getForeignKeys, getFormulae, getFormulaeCanBeGroupedBy, getFormulaeCanBeGroupedBy, getFormulaeForQuery, getFormulaInfo, getFormulasCanBeGroupedBy, getFunctions, getFunctions, getFunctions, getHandle, getHandle, getHDSs, getHDSs, getJoinInfos, getJoinInfos, getJoins, getMapColumns, getMapColumns, getMappingname, getMappingnames, getMappingnames, getNewFormulaName, getNewQueryName, getNewQueryName, getNewReportName, getObjectInfo, getObjectInfo, getObjectInfo, getParameter, getParameterCanBeGroupedBy, getParameterInfo, getPredifinedFilterHandles, getPrimaryKeys, getPrimaryKeys, getPrimaryKeys, getProcColumns, getProcColumns, getProcColumnsMap, getProcColumnsMap, getProcedureNames, getProcedureNames, getQBEInfo, getQBEInfos, getQBEInfos, getQueries, getQuoteChar, getQuoteChar, getQuoteChar, getSPFields, getSPFieldsMap, getSQLColumns, getSQLColumns, getSQLColumnsMap, getSQLColumnsMap, getSQLs, getSQLString, getSQLString, getSQLType, getSQLType, getSubQueries, getSubQueries, getSummaries, getSummariesForQuery, getSummaryCanBeSortedBy, getSummaryInfo, getTableColumns, getTableColumns, getTableColumns, getTableColumns, getTableColumnsMap, getTableColumnsMap, getTableColumnsMap, getTableColumnsMap, getTables, getTables, getTables, getTables, getUDSColumns, getUDSColumns, getUDSColumnsMap, getUDSColumnsMap, getUDSs, getUnionableQueries, getUnionableQueries, getUnionInfos, getUnionInfos, getUnionQueries, getUnionQueries, getUnionQueries, getUnionQueries, getUserID, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insert, insertBLCategory, insertBLDetail, insertBLDimension, insertBLHierarchy, insertBLMeasure, insertBusinessView, insertBusinessView, insertBusinessViewAggregation, insertBusinessViewCategory, insertBusinessViewCategory, insertBusinessViewDetail, insertBusinessViewGroup, insertClassHDS, insertCompCol, insertPredefinedBLFilterInfo, insertSql, insertStoredProcedure, insertTable, insertWSDLConnection, insertXMLHDS, isDistinctQuery, isNameExist, isNameExist, mapFunction, parseFormula, parseFormula, parseFormulae, parseFormulae, refreshReference, rename, rename, save, saveAs, set, set, set, set, set, set, set, set, set, set, set, set, set, set, set, set, set, set, set, setCompCol, setCondition, setDefaultConnection, setDefaultDataSource, setDistinctQuery, setJoin, setModified, setQueryField, setQueryTable, setQueryTable, setQueryTable, updateSQLFile, updateSQLFile, updateUDS, updateUDS`

Methods inherited from class jet.api.API
`clearError, clearMsg, clearWarning, closeLog, containPropName, getBool, getChildren, getClassType, getColor, getDouble, getError, getFloat, getHandles, getHandles, getHandles, getHandles, getInstanceName, getInt, getLong, getParent, getPropNames, getPropType, getQualifyName, getString, getStringArray, getUnit, getWarning, set, set, set, set, set, set, set, setLog, setLog, setLog, setReference, setUnit, writeLog, writeLog`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### save

    public boolean save(java.lang.String uID)
                 throws jet.jetc.WriteFailureException,
                        jet.universe.exception.FMLFileException

  Saves all private objects of the specified user to the public resource (catalog).

  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if saves catalog successfully; `false` otherwise.
  Throws:
    `jet.jetc.WriteFailureException` - If fails to save the catalog file.
    `jet.universe.exception.FMLFileException` - If fails to compile the java class of the formulas in the catalog.

### saveCatalog

    public boolean saveCatalog(java.lang.String uID,
                               java.lang.String dataSource)
                        throws jet.jetc.WriteFailureException,
                               jet.universe.exception.FMLFileException

  Saves the private data objects of the specified user to the public resource (catalog).

  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is the default data source in the catalog.
  Returns:
    `true` if saves catalog successfully; `false` otherwise.
  Throws:
    `jet.jetc.WriteFailureException` - if it fails to save the catalog file.
    `jet.universe.exception.FMLFileException` - if it fails to compile the java class of the formulas in the catalog.

### save

    public boolean save(java.lang.String handle,
                        java.lang.String uID)
                 throws jet.jetc.WriteFailureException,
                        jet.universe.exception.FMLFileException

  Only saves the specified private data object of the specified user to the public resource (the default data source of the catalog).

  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `handle` - The handle of object to be saved to the catalog.
  Returns:
    `true` if it saves catalog successfully; `false` otherwise.
  Throws:
    `jet.jetc.WriteFailureException` - if it fails to save the catalog file.
    `jet.universe.exception.FMLFileException` - if it fails to compile the java class of the formulas in the catalog.

### save

    public boolean save(java.lang.String dataSource,
                        java.lang.String handle,
                        java.lang.String uID)
                 throws jet.jetc.WriteFailureException,
                        jet.universe.exception.FMLFileException

  Only saves the specified private data object of the specified user to the public resource (catalog).

  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `handle` - The handle of object to be saved to the catalog.
  Returns:
    `true` if saves catalog successfully; `false` otherwise.
  Throws:
    `jet.jetc.WriteFailureException` - if fails to save the catalog file.
    `jet.universe.exception.FMLFileException` - if fails to compile the java class of the formulas in the catalog.

### getNewParameterName

    public java.lang.String getNewParameterName(java.lang.String uID)

  Gets the default Parameter name for the Parameter to be created in the current catalog, which must be unique. The first Parameter name is Parameter1, the following will be Parameter2, Parameter3....

  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.

### getNewParameterName

    public java.lang.String getNewParameterName(java.lang.String dataSourceName,
                                                java.lang.String uID)

  Gets the default mapping name for the new parameter in the current catalog, which must be unique. The first Parameter name is Parameter1, the following will be Parameter2, Parameter3...

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the default proper mapping name string.

### getNewSummaryName

    public java.lang.String getNewSummaryName(java.lang.String uID)

  Gets the default mapping name for the Summary to be created in the current catalog, which must be unique. The first Summary name is Summary1, the following will be Summary2, Summary3....

  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the default proper mapping name string.

### getNewSummaryName

    public java.lang.String getNewSummaryName(java.lang.String dataSourceName,
                                              java.lang.String uID)

  Gets the default mapping name for the Summary to be created in the current catalog, which must be unique. The first Summary name is Summary1, the following will be Summary2, Summary3....

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the default proper mapping name string.

### getNewFormulaName

    public java.lang.String getNewFormulaName(java.lang.String uID)

  Gets the default mapping name for the Formula to be created in the current catalog, which must be unique. The first Formula name is Formula1, the following will be Formula2, Formula3....

  Overrides:
    `getNewFormulaName` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the default proper mapping name string.

### getNewFormulaName

    public java.lang.String getNewFormulaName(java.lang.String dataSourceName,
                                              java.lang.String uID)

  Gets the default Formula name for the Formula to be created in the current catalog, which must be unique. The first Formula name is Formula1, the following will be Formula2, Formula3....

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the default proper mapping name string.

### insert

    public java.lang.String insert(java.lang.String name,
                                   int type,
                                   java.lang.String uID)

  Adds a resource entity into the catalog. This method adds a blank object with a specified type into the catalog. Generally, the object is an invalid object before it is initialized with its definition information.

  Parameters:
    `name` - Indicates the mapping name of the new object.
    `type` - Indicates the object type of the new object. The `CatalogAPI` class provides a number of convenient constants that you can use to specify the catalog objects. For example,

    >      CatalogAPI.CONNECTION
    >      CatalogAPI.QUERY
    >      CatalogAPI.TABLE
    >      CatalogAPI.PARAMETER

    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the handle of the new resource entity.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String name,
                                   int type,
                                   java.lang.String uID)

  Adds a resource entity into a specified data source in the catalog. This method adds a blank object with a specified type into the catalog. Generally, the object is an invalid object before it is initialized with its definition information.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is null or "", it means that it is a default data source in the catalog.
    `name` - Indicates the mapping name of the new object.
    `type` - Indicates the object type of the new object. The `CatalogAPI` class provides a number of convenient constants that you can use to specify the catalog objects. For example,

    >      CatalogAPI.CONNECTION
    >      CatalogAPI.QUERY
    >      CatalogAPI.TABLE
    >      CatalogAPI.PARAMETER

    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    handle of the resource entity.

### insert

    public java.lang.String insert(java.lang.String qryName,
                                   QueryFieldInfo queryFieldInfo,
                                   QueryJoinInfo queryJoinInfo,
                                   QueryQBEInfo queryQBEInfo,
                                   QueryAndInfo queryAndInfo,
                                   java.lang.String uID)

  Inserts a query into the catalog.

  Relational databases typically contain many rows of data, with each row constituting a separate record. Most relational database queries retrieve only a portion of the records contained in a table. The WHERE clause qualifies the query command statement to limit the data to specific records from the tables.

  JReport Query's concept is similar to that in the database. The working objects a query can select include tables/views (DBFields), formulas or summaries, and parameters, and the tables/views it can select from are the mapped tables/views defined in a JReport catalog. In this way, a query is independent from the raw database. You can use queries to view, change and analyze data in different ways, and JReport can help you with the building of various professional reports based on queries.

  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `queryFieldInfo` - Indicates the information of the table and fields in the query.
    `queryJoinInfo` - Indicates the joins information of the query.
    `queryQBEInfo` - Indicates the QBE(Query By Example) information of the query.
    `queryAndInfo` - Indicates the where condition information of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the handle of the newly inserted query. If fails, a `null` value will be returned.

### insert

    public java.lang.String insert(java.lang.String dataSourceName,
                                   java.lang.String qryName,
                                   QueryFieldInfo queryFieldInfo,
                                   QueryJoinInfo queryJoinInfo,
                                   QueryQBEInfo queryQBEInfo,
                                   QueryAndInfo queryAndInfo,
                                   java.lang.String uID)

  Inserts a query into the catalog.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `queryFieldInfo` - Indicates the information of the table and fields in the query.
    `queryJoinInfo` - Indicates the joins information of the query.
    `queryQBEInfo` - Indicates the QBE(Query By Example) information of the query.
    `queryAndInfo` - Indicates the where condition information of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the handle of the newly inserted query. If fails, a `null` value will be returned.

### deleteQuery

    public boolean deleteQuery(java.lang.String qryName,
                               java.lang.String uID)

  Deletes the query from the default data source. Note: Only a private resource owned by this user can be removed.

  Overrides:
    `deleteQuery` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteQuery

    public boolean deleteQuery(java.lang.String dataSourceName,
                               java.lang.String qryName,
                               java.lang.String uID)

  Deletes the query from the specified data source of the catalog. Note: Only a private resource owned by this user can be removed.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteTable

    public boolean deleteTable(java.lang.String qryName,
                               java.lang.String tablename,
                               java.lang.String uID)

  Deletes the table from the query. The columns of the table also be removed from the query. Note: Only a private resource owned by this user can be removed.

  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `tablename` - Indicates the mapping name of the table to be deleted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteTable

    public boolean deleteTable(java.lang.String dataSourceName,
                               java.lang.String qryName,
                               java.lang.String tablename,
                               java.lang.String uID)

  Deletes the table from the query. The columns of the table also be removed from the query. Note: Only a private resource owned by this user can be removed.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source.
    `qryName` - Indicates the mapping name of the query.
    `tablename` - Indicates the mapping name of the table to be deleted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteColumn

    public boolean deleteColumn(java.lang.String qryName,
                                java.lang.String tablename,
                                java.lang.String columnname,
                                java.lang.String uID)

  Deletes the field from the query. Note: Only a private resource owned by this user can be removed.

  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `tablename` - the table name of the deleted field.
    `columnname` - the column name of the deleted field.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteColumn

    public boolean deleteColumn(java.lang.String dataSourceName,
                                java.lang.String qryName,
                                java.lang.String tablename,
                                java.lang.String columnname,
                                java.lang.String uID)

  Deletes the field from the query. Note: Only a private resource owned by this user can be removed.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `tablename` - The table name of the deleted field.
    `columnname` - The column name of the deleted field.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String qryName,
                          java.lang.String tableFrom,
                          java.lang.String columnFrom,
                          java.lang.String operator,
                          java.lang.String tableTo,
                          java.lang.String columnTo,
                          java.lang.String uID)

  Deletes the join from the query. Deletes the join whose definition matches the specified information.

  Overrides:
    `delete` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `tableFrom` - The name of the table from which the join links.
    `columnFrom` - The name of the column from which the join links.
    `tableTo` - The name of the table to which the join links.
    `columnTo` - The name of the column to which the join links.
    `operator` - The String operator of the join to be deleted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### delete

    public boolean delete(java.lang.String dataSourceName,
                          java.lang.String qryName,
                          java.lang.String tableFrom,
                          java.lang.String columnFrom,
                          java.lang.String operator,
                          java.lang.String tableTo,
                          java.lang.String columnTo,
                          java.lang.String uID)

  Deletes the join in the query. Deletes the join whose definition matches the specified information.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source.
    `qryName` - Indicates the mapping name of the query.
    `tableFrom` - The name of the table from which the join links.
    `columnFrom` - The name of the column from which the join links.
    `tableTo` - The name of the table to which the join links.
    `columnTo` - The name of the column to which the join links.
    `operator` - The String operator of the join to be deleted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteQBE

    public boolean deleteQBE(java.lang.String qryName,
                             java.lang.String tablename,
                             java.lang.String columnname,
                             java.lang.String expression,
                             java.lang.String uID)

  Deletes the QBE condition in the query. Deletes the QBE condition whose definition matches the specified information. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. For example the QBE might be: table.column (>)= XXX.

  Overrides:
    `deleteQBE` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `tablename` - The name of the table where the QBE condition is.
    `columnname` - The name of the column where the QBE condition is.
    `expression` - The expression of the QBE condition.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteQBE

    public boolean deleteQBE(java.lang.String dataSourceName,
                             java.lang.String qryName,
                             java.lang.String tablename,
                             java.lang.String columnname,
                             java.lang.String expression,
                             java.lang.String uID)

  Deletes the QBE condition in the query. Deletes the QBE condition whose definition matches the specified information. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. For example the QBE might be: table.column (>)= XXX.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `tablename` - The name of the table where the QBE condition is.
    `columnname` - The name of the column where the QBE condition is.
    `expression` - The expression of the QBE condition.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteAND

    public boolean deleteAND(java.lang.String qryName,
                             java.lang.String sExpression1,
                             java.lang.String sOperator,
                             java.lang.String sExpression2,
                             java.lang.String sLogic,
                             java.lang.String uID)

  Deletes where conditions in the query. Deletes the condition whose definition matches the specified information. An example condition could be "sExpression1 sOperator sExpression2 sLogic". If the expression is a field in the query, it must be marked by "@". For example: "@Country = "USA" AND".

  Parameters:
    `qryName` - Indicates the query name in which the where clause stored.
    `sLogic` - The logic string of the where condition to be deleted. The logic describes the relationship between this sentence and the next condition, such as "AND" and "OR".
    `sExpression1` - The first expression of the where condition to be deleted.
    `sOperator` - The operator of the where condition to be deleted.
    `sExpression2` - The second expression of the where condition to be deleted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### deleteAND

    public boolean deleteAND(java.lang.String dataSourceName,
                             java.lang.String qryName,
                             java.lang.String sExpression1,
                             java.lang.String sOperator,
                             java.lang.String sExpression2,
                             java.lang.String sLogic,
                             java.lang.String uID)

  Deletes where conditions in the query. Deletes the condition whose definition matches the specified information. An example condition could be "sExpression1 sOperator sExpression2 sLogic". If the expression is a field in the query, it must be marked by "@". For example: "@Country = "USA" AND".

  Parameters:
    `dataSourceName` - Indicates the mapping name of data source in catalog.
    `qryName` - Indicates the query name in which the where clause stored.
    `sLogic` - The logic string of the where condition to be deleted. The logic describes the relationship between this sentence and the next condition, such as "AND" and "OR".
    `sExpression1` - The first expression of the where condition to be deleted.
    `sOperator` - The operator of the where condition to be deleted.
    `sExpression2` - The second expression of the where condition to be deleted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if deletes successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tablename,
                       boolean selectAllFields,
                       java.lang.String uID)

  Adds a new table into the query.

  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `tablename` - The name of table to be inserted.
    `selectAllFields` - whether or not to insert the table with all its fields. If `true`, all the columns of table also be inserted into the query; `false`, only table without columns be inserted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### setNewTable

    public boolean setNewTable(java.lang.String dataSourceName,
                               java.lang.String qryName,
                               java.lang.String tablename,
                               boolean selectAllFields,
                               java.lang.String uID)

  Adds a new table into the query

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source.
    `qryName` - Indicates the mapping name of the query.
    `tablename` - the real name of table to be inserted
    `selectAllFields` - whether or not to insert the table with all its fields. If `true`, all the columns of table also be inserted into the query; `false`, only table without columns be inserted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tablename,
                       java.lang.String columnname,
                       boolean isFormula,
                       java.lang.String uID)

  Adds a new table's field into the query of the default data source.

  Parameters:
    `qryName` - Indicates the mapping name of the query to be changed.
    `tablename` - Indicates the name of the table to be inserted. If `isFormula` is `true`, this is ignored.
    `columnname` - Indicates the column name of the table to be inserted. If `isFormula` is `true`, this is mapping name of the formula.
    `isFormula` - Indicates whether or not to insert a formula into the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       java.lang.String tablename,
                       java.lang.String columnname,
                       boolean isFormula,
                       java.lang.String uID)

  Adds a new table's field into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query to be changed.
    `tablename` - Indicates the real name of the table to be inserted. If `isFormula` is `true`, this is ignored.
    `columnname` - Indicates the column real name of the table to be inserted. If `isFormula` is `true`, this is mapping name of the formula.
    `isFormula` - Indicates whether or not to insert a formula into the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       java.lang.String tableFrom,
                       java.lang.String columnFrom,
                       java.lang.String operator,
                       java.lang.String tableTo,
                       java.lang.String columnTo,
                       java.lang.String uID)

  Adds a new join to the query. It defines the relationships and creates join among different tables in a query.

  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `tableFrom` - Indicates the name of the table from which the join links.
    `columnFrom` - Indicates the name of the column from which the join links.
    `tableTo` - Indicates the name of the table to which the join links.
    `columnTo` - Indicates the name of the column to which the join links.
    `operator` - Indicates the operator of the join to be inserted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       java.lang.String tableFrom,
                       java.lang.String columnFrom,
                       java.lang.String operator,
                       java.lang.String tableTo,
                       java.lang.String columnTo,
                       java.lang.String uID)

  Adds a new join to the query. It defines the relationships and creates joins among different tables in a query.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `tableFrom` - Indicates the name of the table from which the join links.
    `columnFrom` - Indicates the name of the column from which the join links.
    `tableTo` - Indicates the name of the table to which the join links.
    `columnTo` - Indicates the name of the column to which the join links.
    `operator` - Indicates the operator of the join to be inserted.
    `isSQL92` - Indicates whether or not to apply SQL92 standard to the join sentence.
    `outerJoin` - Indicates the type of the outer join. Constants of Join type:
    - `JoinInfo#LEFTOUTER`
    - `JoinInfo#RIGHTOUTER`
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### setQBE

    public boolean setQBE(java.lang.String qryName,
                          java.lang.String tablename,
                          java.lang.String columnname,
                          java.lang.String expression,
                          java.lang.String uID)

  Adds a QBE condition into the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. For example the QBE might be: table.column (>)= XXX.

  Overrides:
    `setQBE` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query to be changed.
    `tablename` - The name of the table where the QBE condition will be added.
    `columnname` - The name of the column where the QBE condition will be added.
    `expression` - The expression of the QBE condition.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### setQBE

    public boolean setQBE(java.lang.String dataSourceName,
                          java.lang.String qryName,
                          java.lang.String tablename,
                          java.lang.String columnname,
                          java.lang.String expression,
                          java.lang.String uID)

  Adds a QBE condition into the query. The QBE(Query By Example) is a filter by which you can define certain criteria for the fields of a query to be retrieved from the database, so that when you build reports on the query, the returned results will be narrowed down. For example the QBE might be: table.column (>)= XXX.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query to be changed.
    `tablename` - The name of the table where the QBE condition will be added.
    `columnname` - The name of the column where the QBE condition will be added.
    `expression` - The expression of the QBE condition.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### setAND

    public boolean setAND(java.lang.String qryName,
                          java.lang.String sExpression1,
                          java.lang.String sOperator,
                          java.lang.String sExpression2,
                          java.lang.String sLogic,
                          java.lang.String uID)

  Adds a new where condition to the specified query. The added sentence will append to the end of the existing whereclause in the query. And the sLogic parameter of this sentence will connect the next available condition; if it is null, it means the end of the query's whereclause.

  Parameters:
    `qryName` - Indicates the mapping name of the query to be changed.
    `sLogic` - The logic string of the where condition to be inserted.
    `sExpression1` - The first expression of the where condition to be inserted.
    `sOperator` - The operator of the where condition to be inserted.
    `sExpression2` - The second expression of the where condition to be inserted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### setAND

    public boolean setAND(java.lang.String dataSourceName,
                          java.lang.String qryName,
                          java.lang.String sExpression1,
                          java.lang.String sOperator,
                          java.lang.String sExpression2,
                          java.lang.String sLogic,
                          java.lang.String uID)

  Adds a new where condition to the specified query. The added sentence will append to the end of the existing whereclause in the query. And the sLogic parameter of this sentence will connect the next available condition; if it is null, it means the end of the query's whereclause.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query to be changed.
    `sLogic` - The logic string of the where condition to be inserted.
    `sExpression1` - The first expression of the where condition to be inserted.
    `sOperator` - The operator of the where condition to be inserted.
    `sExpression2` - The second expression of the where condition to be inserted.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String handle,
                       FormulaInfo info,
                       java.lang.String uID)

  Sets the Formula's information. It changes the definition of the Formula according to the new information.

  Parameters:
    `handle` - Indicates the handle of the Formula. The handle is the unique ID of the object in the catalog.
    `info` - Indicates the new formula's information.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if modifies data object successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       UnionInfo unionInfo,
                       java.lang.String uID)

  Adds a union query into the query of the default data source.

  Parameters:
    `qryName` - Indicates the mapping name of the query to be changed.
    `unionInfo` - Union query information.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       UnionInfo unionInfo,
                       java.lang.String uID)

  Adds a union query into the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query to be changed.
    `unionInfo` - Union query information.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String qryName,
                       SubQueryInfo subqueryInfo,
                       java.lang.String uID)

  Adds a subquery into the query of the specified data source. The SQL sentence of the subquery will be merged into the where clause of the main query.

  Parameters:
    `qryName` - Indicates the mapping name of the query to be changed.
    `subqueryInfo` - The class defines the subquery's information.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### set

    public boolean set(java.lang.String dataSourceName,
                       java.lang.String qryName,
                       SubQueryInfo subqueryInfo,
                       java.lang.String uID)

  Adds a subquery into the query of the specified data source. The SQL sentence of the subquery will be merged into the where clause of the main query.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query to be changed.
    `subqueryInfo` - The class defines the subquery's information.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    `true` if inserts successfully; `false` otherwise.

### getDBFields

    public java.lang.String[] getDBFields(java.lang.String qryName,
                                          java.lang.String uID)

  Gets mapping names of DBField that are defined in the query of the default data source.

  Overrides:
    `getDBFields` in class `CatalogAPI`
  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the mapping names array of the fields in the query.

### getDBFields

    public java.lang.String[] getDBFields(java.lang.String dataSourceName,
                                          java.lang.String qryName,
                                          java.lang.String uID)

  Gets mapping names of DBFields that are defined in the query of the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `qryName` - Indicates the mapping name of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the mapping names array of the fields in the query.

### getFormulae

    public java.lang.String[] getFormulae(java.lang.String uID)

  Gets all formulas' mapping names that are defined in the default data source.

  Overrides:
    `getFormulae` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the formulas in the default data source.

### getFormulae

    public java.lang.String[] getFormulae(java.lang.String dataSourceName,
                                          java.lang.String uID)

  Gets all formulas' mapping names that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the formulas.

### getSummaries

    public java.lang.String[] getSummaries(java.lang.String uID)

  Gets all summaries mapping names that are defined in the specified data source.

  Overrides:
    `getSummaries` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the summaries.

### getSummaries

    public java.lang.String[] getSummaries(java.lang.String dataSourceName,
                                           java.lang.String uID)

  Gets all summaries mapping names that are defined in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the summaries.

### getSQLs

    public java.lang.String[] getSQLs(java.lang.String uID)

  Gets all mapping names of Imported SQL queries in the default data source.

  Overrides:
    `getSQLs` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the Imported SQL queries.

### getSQLs

    public java.lang.String[] getSQLs(java.lang.String dataSourceName,
                                      java.lang.String uID)

  Gets all mapping names of Imported SQL queries in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the Imported SQL queries.

### getUDSs

    public java.lang.String[] getUDSs(java.lang.String uID)

  Gets all mapping names of UDSs in the default data source.

  Overrides:
    `getUDSs` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the UDSs.

### getUDSs

    public java.lang.String[] getUDSs(java.lang.String dataSourceName,
                                      java.lang.String uID)

  Gets all mapping names of UDSs in the default data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the UDSs.

### getParameter

    public java.lang.String[] getParameter(java.lang.String uID)

  Gets all mapping names of Parameters in the default data source.

  Overrides:
    `getParameter` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the parameters.

### getParameter

    public java.lang.String[] getParameter(java.lang.String dataSourceName,
                                           java.lang.String uID)

  Gets all mapping names of Parameters in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the Parameters.

### getQueries

    public java.lang.String[] getQueries(java.lang.String uID)

  Gets all mapping names of Queries in the default data source.

  Overrides:
    `getQueries` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the queries.

### getQueries

    public java.lang.String[] getQueries(java.lang.String dataSourceName,
                                         java.lang.String uID)

  Gets all mapping names of Queries in the default data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the queries.

### getTables

    public java.lang.String[] getTables(java.lang.String uID)

  Gets all mapping names of Tables in the default data source.

  Overrides:
    `getTables` in class `CatalogAPI`
  Parameters:
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the tables.

### getTables

    public java.lang.String[] getTables(java.lang.String dataSourceName,
                                        java.lang.String uID)

  Gets all mapping names of Tables in the specified data source.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of the mapping names of the tables.

### getColumns

    public QueryTableInfo getColumns(java.lang.String queryName,
                                     boolean allColumns,
                                     java.lang.String uID)

  Gets definitions of all tables and columns in the query.

  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `allColumns` - select all columns in selected tables
  Returns:
    the QueryTableInfo defines the tables and columns in the query.

### getColumns

    public QueryTableInfo getColumns(java.lang.String dataSourceName,
                                     java.lang.String queryName,
                                     boolean allColumns,
                                     java.lang.String uID)

  Gets definitions of all tables and columns in the query.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `queryName` - Indicates the mapping name of the query.
    `allColumns` - Indicates where or not to include all columns that are defined in the selected database tables.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the QueryTableInfo defines the tables and columns in the query.

### getCompColumns

    public java.lang.String[] getCompColumns(java.lang.String queryName,
                                             java.lang.String uID)

  Gets all mapping names of the computed columns in the query.

  Overrides:
    `getCompColumns` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of mapping names of the computed columns.

### getCompColumns

    public java.lang.String[] getCompColumns(java.lang.String dataSourceName,
                                             java.lang.String queryName,
                                             java.lang.String uID)

  Gets all mapping names of the computed columns in the query.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source. If it is `null` or "", it means that it is default data source in the catalog.
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    a list of mapping names of the computed columns.

### getJoins

    public java.lang.String[][] getJoins(java.lang.String queryName,
                                         java.lang.String uID)

  Gets joins in the query

  Overrides:
    `getJoins` in class `CatalogAPI`
  Parameters:
    `queryName` - The mapping name of the query.
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    join info array. note: String[i][0] = Table "From" Name, String[i][1] = Column "From" Name, String[i][2] = Table "To" Name, String[i][3] = Column "To" Name String[i][4] = operator String[i][5] = string value of isSQL92 String[i][6] = string value of outer join type

### getJoins

    public java.lang.String[][] getJoins(java.lang.String dataSourceName,
                                         java.lang.String queryName,
                                         java.lang.String uID)

  Gets joins in the query

  Parameters:
    `dataSourceName` - the name of data source
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    join info array. note: String[i][0] = Table "From" Name, String[i][1] = Column "From" Name, String[i][2] = Table "To" Name, String[i][3] = Column "To" Name String[i][4] = operator String[i][5] = string value of isSQL92 String[i][6] = string value of outer join type

### getQBEInfo

    public java.lang.String[][] getQBEInfo(java.lang.String queryName,
                                           java.lang.String uID)

  Gets QBE information in the query

  Overrides:
    `getQBEInfo` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    QBE info array note:String[i][0] = table Name, String[i][1] = column Name, String[i][j](j>1) = condition expression of this column,

### getQBEInfo

    public java.lang.String[][] getQBEInfo(java.lang.String dataSourceName,
                                           java.lang.String queryName,
                                           java.lang.String uID)

  Gets QBE information in the query

  Parameters:
    `dataSourceName` - the data source name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `queryName` - the query name
  Returns:
    QBE info array note:String[i][0] = table Name, String[i][1] = column Name, String[i][j](j>1) = condition expression of this column,

### getAndConditions

    public java.lang.String[][] getAndConditions(java.lang.String queryName,
                                                 java.lang.String uID)

  Gets "AND" conditions in the query

  Overrides:
    `getAndConditions` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    condition info array. note: String[i][0] = "Logic" String[i][1] = "Expression1", String[i][2] = "Operator", String[i][3] = "Expression2"

### getAndConditions

    public java.lang.String[][] getAndConditions(java.lang.String dataSourceName,
                                                 java.lang.String queryName,
                                                 java.lang.String uID)

  Gets "AND" conditions in the query

  Parameters:
    `dataSourceName` - the data source name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `queryName` - the query name
  Returns:
    condition info array. note: String[i][0] = "Logic" String[i][1] = "Expression1", String[i][2] = "Operator", String[i][3] = "Expression2"

### getColumnMappingnames

    public java.lang.String[] getColumnMappingnames(java.lang.String queryName,
                                                    java.lang.String uID)

  Gets column mapping names in the query

  Overrides:
    `getColumnMappingnames` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the table name and column mapping names

### getColumnMappingnames

    public java.lang.String[] getColumnMappingnames(java.lang.String dataSourceName,
                                                    java.lang.String queryName,
                                                    java.lang.String uID)

  Gets column mapping names in the query

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the table name and column mapping names

### getColumnsCanBeGroupedBy

    public QueryTableInfo getColumnsCanBeGroupedBy(java.lang.String queryName,
                                                   java.lang.String uID)

  Gets columns which can be groupby in the query

  Overrides:
    `getColumnsCanBeGroupedBy` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the column mapping names

### getColumnsCanBeGroupedBy

    public QueryTableInfo getColumnsCanBeGroupedBy(java.lang.String dataSourceName,
                                                   java.lang.String queryName,
                                                   java.lang.String uID)

  Gets columns which can be groupby in the query

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the column mapping names

### getFormulaeForQuery

    public java.lang.String[] getFormulaeForQuery(java.lang.String queryName,
                                                  java.lang.String uID)

  Gets formulas which are valid to query

  Overrides:
    `getFormulaeForQuery` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula names

### getFormulaeForQuery

    public java.lang.String[] getFormulaeForQuery(java.lang.String dataSourceName,
                                                  java.lang.String queryName,
                                                  java.lang.String uID)

  Gets formulas which are valid to query

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula names

### getSummariesForQuery

    public java.lang.String[] getSummariesForQuery(java.lang.String queryName,
                                                   java.lang.String uID)

  Gets Summaries which are valid to query

  Overrides:
    `getSummariesForQuery` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the Summary names

### getSummariesForQuery

    public java.lang.String[] getSummariesForQuery(java.lang.String dataSourceName,
                                                   java.lang.String queryName,
                                                   java.lang.String uID)

  Gets Summaries which are valid to query

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the Summary names

### getFmlCanBeGroupedBy

    public java.lang.String[] getFmlCanBeGroupedBy(java.lang.String queryName,
                                                   java.lang.String uID)

  Gets formulas which are valid to query and can be grouped on

  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula names

### getFmlCanBeGroupedBy

    public java.lang.String[] getFmlCanBeGroupedBy(java.lang.String dataSourceName,
                                                   java.lang.String queryName,
                                                   java.lang.String uID)

  Gets formulas which are valid to query and can be grouped on

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula names

### getFormulaeCanBeGroupedBy

    public java.lang.String[] getFormulaeCanBeGroupedBy(java.lang.String queryName,
                                                        java.lang.String groupBy,
                                                        java.lang.String uID)

  Gets formulas which are valid to query

  Overrides:
    `getFormulaeCanBeGroupedBy` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
    `groupBy` - Indicates the resource name of the query.
  Returns:
    the formula names

### getFormulaeCanBeGroupedBy

    public java.lang.String[] getFormulaeCanBeGroupedBy(java.lang.String dataSourceName,
                                                        java.lang.String queryName,
                                                        java.lang.String groupBy,
                                                        java.lang.String uID)

  Gets formulas which are valid to query

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula names

### getChartFunctions

    public java.lang.String[] getChartFunctions(java.lang.String queryName,
                                                java.lang.String groupBy,
                                                java.lang.String uID)

  Gets formulas and summaries which are valid to the query and are grouped on this field.

  Overrides:
    `getChartFunctions` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `groupBy` - the groupBy field name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula and summary names

### getChartFunctions

    public java.lang.String[] getChartFunctions(java.lang.String dataSourceName,
                                                java.lang.String queryName,
                                                java.lang.String groupBy,
                                                java.lang.String uID)

  Gets formulas and summaries which are valid to the query and are grouped on this field.

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `groupBy` - the groupBy field name
    `uID` - The user id to identify the proper user while several users share the `MultiUserCatalogAPI`. Use `uID` to access the user's private data.
  Returns:
    the formula and summary names

### getParameterCanBeGroupedBy

    public java.lang.String[] getParameterCanBeGroupedBy(java.lang.String uID)

  Gets parameters which can be grouped by

  Overrides:
    `getParameterCanBeGroupedBy` in class `CatalogAPI`
  Parameters:
    `uID` - the User ID
  Returns:
    parameter names

### getParameterCanBeGroupedBy

    public java.lang.String[] getParameterCanBeGroupedBy(java.lang.String dataSourceName,
                                                         java.lang.String uID)

  Gets parameters which can be grouped by

  Parameters:
    `dataSourceName` - the data source name
    `uID` - the User ID
  Returns:
    parameter names

### getSummaryCanBeSortedBy

    public java.lang.String[] getSummaryCanBeSortedBy(java.lang.String queryName,
                                                      java.lang.String groupBy,
                                                      java.lang.String uID)

  Gets summary which can be sorted by

  Overrides:
    `getSummaryCanBeSortedBy` in class `CatalogAPI`
  Parameters:
    `queryName` - the query name
    `groupBy` - the groupBy field
    `uID` - the User ID
  Returns:
    summary names

### getSummaryCanBeSortedBy

    public java.lang.String[] getSummaryCanBeSortedBy(java.lang.String dataSourceName,
                                                      java.lang.String queryName,
                                                      java.lang.String groupBy,
                                                      java.lang.String uID)

  Gets summary which can be sorted by

  Parameters:
    `dataSourceName` - the data source name
    `queryName` - the query name
    `groupBy` - the groupBy field
    `uID` - the User ID
  Returns:
    summary names

### isModified

    public boolean isModified()

  whether the catalog was modified

  Overrides:
    `isModified` in class `CatalogAPI`
  Returns:
    true if catalog was modified

### getHandle

    public java.lang.String getHandle(java.lang.String resourceName,
                                      java.lang.String uID)

  get the object handle

  Parameters:
    `resourceName` - object mapping name
    `uID` - user ID
  Returns:
    the object handle

### getHandle

    public java.lang.String getHandle(java.lang.String dataSourceName,
                                      java.lang.String resourceName,
                                      java.lang.String uID)

  get the object handle

  Parameters:
    `resourceName` - object mapping name
    `uID` - user ID
  Returns:
    the object handle

### getHandle

    public java.lang.String getHandle(java.lang.String resourceName,
                                      int type,
                                      java.lang.String uID)

  get the object handle

  Parameters:
    `resourceName` - object mapping name
    `type` - object type
    `uID` - user ID
  Returns:
    the object handle

### getHandle

    public java.lang.String getHandle(java.lang.String dataSourceName,
                                      java.lang.String resourceName,
                                      int type,
                                      java.lang.String uID)

  Gets the handle of an object according to the object's mapping name and object type in the specified data source in JReport catalog, which can identify the object in the catalog. Mapping name is not the unique name of the object in the catalog.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source to get the object's handle. If it is null or "", it means it is the default data source in the catalog.
    `resourceName` - Indicates the mapping name of the object in the specified data source.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CatalogAPI.CONNECTION
    >      CatalogAPI.QUERY
    >      CatalogAPI.TABLE
    >      CatalogAPI.PARAMETER

  Returns:
    `null` if there is no matching object, otherwise returns a String specifying the handle of the object.

### rename

    public java.lang.String rename(java.lang.String resourceName,
                                   java.lang.String newName,
                                   int type,
                                   java.lang.String uID)

  Renames the mapping name of the specified object.

  Parameters:
    `resourceName` - Resource name(mapping name) of the object.
    `newName` - New resource name of the object.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CatalogAPI.CONNECTION
    >      CatalogAPI.QUERY
    >      CatalogAPI.TABLE
    >      CatalogAPI.PARAMETER

  Returns:
    the new resource name if it renames successfully; `null` otherwise.

### rename

    public java.lang.String rename(java.lang.String dataSourceName,
                                   java.lang.String resourceName,
                                   java.lang.String newName,
                                   int type,
                                   java.lang.String uID)

  Renames the mapping name of the specified object.

  Parameters:
    `dataSourceName` - Indicates the mapping name of the data source in the catalog.
    `resourceName` - Resource name(mapping name) of the object.
    `newName` - New resource name of the object.
    `type` - Indicates the type of the object by constant object type value. The `CatalogAPI` class provides a number of convenient constants that you can use to specify catalog objects. For example,

    >      CatalogAPI.CONNECTION
    >      CatalogAPI.QUERY
    >      CatalogAPI.TABLE
    >      CatalogAPI.PARAMETER

  Returns:
    the new resource name if it renames successfully; `null` otherwise.

### insertCompCol

    public java.lang.String insertCompCol(java.lang.String qryName,
                                          java.lang.String columnName,
                                          java.lang.String sExpression,
                                          java.lang.String uID)

  Inserts a computed column into query.

  Overrides:
    `insertCompCol` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `columnName` - the resource name of computed column
    `sExpression` - the expression of this column
    `uID` - Indicates the expression String of this computed column.
  Returns:
    the handle of the newly inserted column. If fails, a null value will be returned.

### insertCompCol

    public java.lang.String insertCompCol(java.lang.String dataSourceName,
                                          java.lang.String qryName,
                                          java.lang.String columnName,
                                          java.lang.String sExpression,
                                          java.lang.String uID)

  Inserts a computed column into query.

  Parameters:
    `dataSourceName` - the name of data source
    `qryName` - Indicates the mapping name of the query.
    `columnName` - the resource name of computed column
    `sExpression` - the expression of this column
  Returns:
    the handle of the newly inserted column. If fails, a null value will be returned.

### deleteCompCol

    public boolean deleteCompCol(java.lang.String qryName,
                                 java.lang.String columnName,
                                 java.lang.String uID)

  delete a computed column into query.

  Overrides:
    `deleteCompCol` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `columnName` - the resource name of computed column
    `uID` - Indicates the mapping name of the computed column.
  Returns:
    the handle of the newly inserted column. If fails, a null value will be returned.

### deleteCompCol

    public boolean deleteCompCol(java.lang.String dataSourceName,
                                 java.lang.String qryName,
                                 java.lang.String columnName,
                                 java.lang.String uID)

  delete a computed column into query.

  Parameters:
    `dataSourceName` - the name of data source
    `qryName` - Indicates the mapping name of the query.
    `columnName` - the resource name of computed column
  Returns:
    the handle of the newly inserted column. If fails, a null value will be returned.

### setCompCol

    public boolean setCompCol(java.lang.String qryName,
                              java.lang.String columnName,
                              java.lang.String sExpression,
                              java.lang.String uID)

  modify the expression of a computed column .

  Overrides:
    `setCompCol` in class `CatalogAPI`
  Parameters:
    `qryName` - Indicates the mapping name of the query.
    `columnName` - the resource name of computed column
    `sExpression` - the expression of this column
    `uID` - Indicates the new expression String of the computed column.
  Returns:
    the handle of the newly inserted column. If fails, a null value will be returned.

### setCompCol

    public boolean setCompCol(java.lang.String dataSourceName,
                              java.lang.String qryName,
                              java.lang.String columnName,
                              java.lang.String sExpression,
                              java.lang.String uID)

  modify the expression of a computed column .

  Parameters:
    `dataSourceName` - the name of data source
    `qryName` - Indicates the mapping name of the query.
    `columnName` - the resource name of computed column
    `sExpression` - the expression of this column
  Returns:
    the handle of the newly inserted column. If fails, a null value will be returned.

### insertSql

    public java.lang.String insertSql(java.lang.String dataSourceName,
                                      java.lang.String SQLName,
                                      java.lang.String filename,
                                      java.lang.String uID)

  Imports an SQL file

  Overrides:
    `insertSql` in class `CatalogAPI`
  Parameters:
    `dataSourceName` - the data source name
    `SQLName` - the SQL name
    `filename` - the imported file name
    `uID` - Indicates the full path file name of the imported query.
  Returns:
    the handle of the newly inserted file sql. If fails, a null value will be returned.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD